import sys
sys.path.append('d:/PoeTrader')
from src import config
from src.data import Message
from trade_widget import TradeCollection
from PySide6 import QtCore
from PySide6.QtWidgets import QApplication, QMainWindow, QVBoxLayout, QTabWidget


class MainWindow(QMainWindow):
    def __init__(self):
        super().__init__()

        config.read_config(r'config.yaml')
        self.setWindowFlag(QtCore.Qt.FramelessWindowHint)
        self.setAttribute(QtCore.Qt.WA_TranslucentBackground)

        self.trades = {}

        text = '2021/03/08 23:24:52 17931875 bb3 [INFO Client 1492] @From Sinusal: Hi, I would like to buy your level 21 23% Vaal Impurity of Lightning ' \
            'listed for 18 chaos in Ritual (stash tab "$"; position: left 22, top 5)'
        text2 = '2021/03/08 23:24:52 17931875 bb3 [INFO Client 1492] @From NiceGuy: Hi, I would like to buy your level 21 23% Vaal Impurity of Lightning ' \
            'listed for 18 chaos in Ritual (stash tab "$"; position: left 22, top 5)'
        message = Message.from_text(text)
        message2 = Message.from_text(text2)
        self.setWindowTitle("My App")

        self.main_widget = QTabWidget()

        # self.main_layout = QVBoxLayout()
        self.new_trade(message)
        self.new_trade(message)
        self.new_trade(message2)

        self.setCentralWidget(self.main_widget)

    def new_trade(self, message: Message):
        if message.trade:
            unique_item = message.trade.unique_item()
            if unique_item in self.trades:
                self.trades[unique_item].add_trade(message)
            else:
                collection = TradeCollection(message)
                self.trades[message.trade.unique_item()] = collection
                self.main_widget.addTab(collection, message.trade.item)


if __name__ == "__main__":
    pass
    app = QApplication(sys.argv)
    app.setStyle('Material')

    window = MainWindow()
    window.show()

    app.exec()
